--  Implementacion del protocolo Local


-- ---------------------------------------
--  with Ada.Text_IO; use Ada.Text_IO;
with POSIX.Generic_Shared_Memory;
with POSIX.Memory_Mapping; use POSIX.Memory_Mapping;
with POSIX.IO;
--  with System;
with MaRTE_Semaphores; use MaRTE_Semaphores;  --
with POSIX_Mutexes; use POSIX_Mutexes;
--  with Ada.Exceptions;
-- ---------------------------------------
--  with System.Garlic.Streams; use System.Garlic.Streams;
--  with Ada.Streams; use Ada.Streams;

package body Local_Protocol is
   Initialized_Is : Boolean := False;
   El_Prio_Ceiling : Integer;

   type Mi_Object_Type is record
      --  *************
      El_Mutex : Mutex;
      Los_Attributes : Attributes;
      El_Mutex_Desc : Mutex_Descriptor;
      --  *************
      --  ------------
      Sem : aliased Semaphore;
      --  ------------
      Length_Stream : Ada.Streams.Stream_Element_Offset;
      El_Stream : Mi_Data;
   end record;
--   type Acc_Mi_Obj is access all Mi_Object_Type;

   package Mi_Mem_Shared is new POSIX.Generic_Shared_Memory (Mi_Object_Type);

   use Mi_Mem_Shared;
   Puntero : Shared_Access;
   --  Mi_Object_Type;


   --  //////////////////////////
   --  // Init_local_Protocol  //
   --  //////////////////////////
   function Init_Local_Protocol (Prio_Ceiling : Integer) return Integer is
      Res : POSIX.IO.File_Descriptor := 0;
   begin
      El_Prio_Ceiling := Prio_Ceiling;
      Res := Mi_Mem_Shared.Open_And_Map_Shared_Memory ("HI", Allow_Read);
      Puntero := Access_Shared_Memory (Res);
      return 0;  --  Integer (Res);
   end Init_Local_Protocol;


   --  /////////////////////////////
   --  // Is_Initialized          //
   --  /////////////////////////////
   function Is_Initialized return Boolean is
   begin
      return Initialized_Is;
   end Is_Initialized;


   --  /////////////////////////////
   --  // Init_Mutex_Sem          //
   --  /////////////////////////////
   procedure Init_Mutex_Sem is
      --  ------------
      Res_Sem : Integer := 0;
      --  ------------
   begin
      if Initialized_Is = False then
         --  *************
         Initialize (Puntero.Los_Attributes);
         Set_Locking_Policy (Puntero.Los_Attributes, HIGHEST_CEILING_PRIORITY);
         --         Put_Line ("Tras Set_Locking_Policy");
         Set_Ceiling_Priority (Puntero.Los_Attributes, El_Prio_Ceiling);
         --         Put_Line ("Tras Set_Ceiling_Policy");
         Initialize (Puntero.El_Mutex, Puntero.Los_Attributes);
         --         Put_Line ("Tras Initialize");
         Puntero.El_Mutex_Desc := Descriptor_Of (Puntero.El_Mutex);
         --         Put_Line ("Tras Get_Descriptor_Of");
         --  *************
         --  ------------
         Res_Sem := Initialize (Puntero.Sem'Unchecked_Access, 0, 0);  --
--         Put_Line ("Inicializo el semaforo  ((" & Res_Sem'Img & "))");  --
         --  ------------

         Initialized_Is := True;
      end if;
   end Init_Mutex_Sem;

   --  //////////////////////////
   --  // Generic_Send_Info    //
   --  //////////////////////////
--   procedure Generic_Send_Info
   procedure Send_Info
     (Destination_Address : in Integer;
      Channel_ID : in Integer;
      --     Data : in Data_Type;
      --  Data : in Mi_Data;
      Data : access Ada.Streams.Stream_Element_Array;
--      Data : in Stream_Element_Access;  --  access Stream_Element_Array;
      Size : in Integer;
      Data_Priority : in Integer) is

      Res_Sem : Integer := 0;
      First    : Stream_Element_Count := Data'Last + 1
                                         - Stream_Element_Count (Size);

   begin

      --      Put_Line ("--Tx::Inicio");
      Lock (Puntero.El_Mutex_Desc);
      --      Put_Line ("--Tx::Tras Lock");

      --  ++++++++(I) OPERO +++++++++++++++
      --      Put_Line ("--Tx::El_Entero  =>" & Puntero.El_Entero'Img);
      --      Put_Line ("    ::El_Entero2 =>" & Puntero.El_Entero2'Img);
      Puntero.Length_Stream := Data'Last - First + 1;
      Puntero.El_Stream (1 .. Puntero.Length_Stream) :=
        Data (First .. Data'Last);
      --  ++++++++(F) OPERO +++++++++++++++



      --  ++++++++ SENALIZO DATO DISPONIBLE +++++++++++++++
      --  ------------
--    Put_Line ("--Tx::Semaforo VOY A senalizar  ((" & Res_Sem'Img & "))");  --
--      Res_Sem := Post (Puntero.Sem'Unchecked_Access);  --
      Res_Sem := Post (Puntero.Sem'Access);  --
--      Put_Line ("--Tx::Semaforo senalizado ((" & Res_Sem'Img & "))");  --
      --  ------------



      Unlock (Puntero.El_Mutex_Desc);
--      Put_Line ("--Tx::Tras Unlock");


--   end Generic_Send_Info;
   end Send_Info;


   --  //////////////////////////
   --  // Generic_Recv_Info    //
   --  //////////////////////////
--   procedure Generic_Recv_Info
   procedure Recv_Info
     (Source_Address : in Integer;
      Channel_ID : in Integer;
      --      Data : out Data_Type;
      --  Data : out Mi_Data;
      Data : access Ada.Streams.Stream_Element_Array;
--      Data : out Stream_Element_Access;  --  access Stream_Element_Array;
      Size : out Integer;
      Data_Priority : out Integer) is


      Res_Sem : Integer := 0;
   begin
      --  ++++++++ ESPERO indicacion  DATO DISPONIBLE +++++++++++++++
--      Put_Line ("--Rx::Inicio");
      --  ------------
--      Put_Line ("--Rx::Antes del semaforo");
      Res_Sem := Wait (Puntero.Sem'Access);  --
--      Res_Sem := Wait (Puntero.Sem'Unchecked_Access);  --
--      Put_Line ("--Rx::Semaforo espera ((" & Res_Sem'Img & "))");  --
      --  ------------
      --      Put_Line ("--Rx::Inicio");
--      Lock (Puntero.El_Mutex_Desc);
      --      Put_Line ("--Rx::Tras Lock");

      --  ++++++++(I) OPERO +++++++++++++++
--      Put_Line ("--Rx::El_Entero  =>" & Puntero.El_Entero'Img);
--      Put_Line ("--  ::El_Entero2 =>" & Puntero.El_Entero2'Img);
      Data (1 .. Puntero.Length_Stream) :=
        Puntero.El_Stream (1 .. Puntero.Length_Stream);
      Size := Integer (Puntero.Length_Stream);
      Data_Priority := 1;
      --  ++++++++(F) OPERO +++++++++++++++

--      Unlock (Puntero.El_Mutex_Desc);
      --      Put_Line ("--Rx::Tras Unlock");

--   end Generic_Recv_Info;
   end Recv_Info;

end Local_Protocol;
