------------------------------------------------------------------------------
--                                                                          --
--                            GLADE COMPONENTS                              --
--                                                                          --
--             S Y S T E M . G A R L I C . P R I O R I T I E S              --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                            $Revision: 1.14 $
--                                                                          --
--         Copyright (C) 1996-2001 Free Software Foundation, Inc.           --
--                                                                          --
-- GARLIC is free software;  you can redistribute it and/or modify it under --
-- terms of the  GNU General Public License  as published by the Free Soft- --
-- ware Foundation;  either version 2,  or (at your option)  any later ver- --
-- sion.  GARLIC is distributed  in the hope that  it will be  useful,  but --
-- WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHANTABI- --
-- LITY or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public  --
-- License  for more details.  You should have received  a copy of the GNU  --
-- General Public License  distributed with GARLIC;  see file COPYING.  If  --
-- not, write to the Free Software Foundation, 59 Temple Place - Suite 330, --
-- Boston, MA 02111-1307, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
--               GLADE  is maintained by ACT Europe.                        --
--               (email: glade-report@act-europe.fr)                        --
--                                                                          --
------------------------------------------------------------------------------

package System.Garlic.Priorities is

   --  This package implements the suggestion from IRTAW99 and some
   --  enhancements taken from CORBA.

   --  Portable priorities
   type Global_Priority is range 0 .. 255;

   --  During a RPC, set rpc handler priority either to default
   --  priority (server_declared) or to client priority
   --  (client_propagated).
--  jl   type Priority_Policy is (Server_Declared, Client_Propagated);

--  jl   Default_RPC_Handler_Priority_Policy : constant Priority_Policy
--  jl     := Client_Propagated;

   Default_RPC_Handler_Priority : constant Global_Priority
     := Global_Priority'Last;

   RPC_Handler_Priority : Global_Priority
     := Default_RPC_Handler_Priority;

--  jl    RPC_Handler_Priority_Policy : Priority_Policy
--  jl     := Default_RPC_Handler_Priority_Policy;



   --  jl (I) -------------------------------------
   RPCSER_AnTask : constant Priority := Default_Priority;      --  jl
   PRIO_ACCEPT_HANDLER : constant Priority := 29;   --  jl MODIFICO
   PRIO_CONNECT_HANDLER : constant Priority := 29;  --  jl MODIFICO
   My_IRpcHPrio : Natural := PRIO_ACCEPT_HANDLER;
   ------------------------
   --  Prioridades Send  --
   ------------------------
   --  s-rpc
   RPC_FINALIZE : constant Natural := Natural (Priority'Last);        --  jl

   --  s-rpcser
   RPC_ABORT_REPLAY : constant Natural := Natural (Priority'Last);    --  jl

   --  s-rpstio
   RPSTIO_CLOSE : constant Natural := Natural (Priority'Last);        --  jl

   --  s-garhea
   SHUTDOWN_OPERATION : constant Natural := Natural (Priority'Last);  --  jl
   SEND_BOOT_SERVER : constant Natural := Natural (Priority'Last);    --  jl
   --  *

   --  s-garfil
   --  *

   --  s-gargro
   SEND_NEXT_MIRROR : constant Natural := Natural (Priority'Last);    --  jl

   --  s-garter
   SHUT_SERV_ANSWER : constant Natural := Natural (Priority'Last);    --  jl
   SHUT_SERV_SEND : constant Natural := Natural (Priority'Last);      --  jl
   SHUT_SEND_WAVE : constant Natural := Natural (Priority'Last);      --  jl

   --  s-garuni
   --  Unit_Naming_Service -> answer pending request
   UNS_ANS_PEND_REQ : constant Natural := Natural (Priority'Last);    --  jl

   --  s-gastds
   DSM_SERV_SEND : constant Natural := Natural (Priority'Last);       --  jl
   --  jl (F) -------------------------------------



   procedure Set_RPC_Handler_Priority
     (A_Priority : in Global_Priority);

--  jl   procedure Set_RPC_Handler_Priority_Policy
--  jl     (A_Policy : in Priority_Policy);

end System.Garlic.Priorities;
