------------------------------------------------------------------------------
--                                                                          --
--                            GLADE COMPONENTS                              --
--                                                                          --
--              S Y S T E M . G A R L I C . P R O T O C O L S               --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--                            $Revision: 1.16 $
--                                                                          --
--         Copyright (C) 1996-2001 Free Software Foundation, Inc.           --
--                                                                          --
-- GARLIC is free software;  you can redistribute it and/or modify it under --
-- terms of the  GNU General Public License  as published by the Free Soft- --
-- ware Foundation;  either version 2,  or (at your option)  any later ver- --
-- sion.  GARLIC is distributed  in the hope that  it will be  useful,  but --
-- WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHANTABI- --
-- LITY or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public  --
-- License  for more details.  You should have received  a copy of the GNU  --
-- General Public License  distributed with GARLIC;  see file COPYING.  If  --
-- not, write to the Free Software Foundation, 59 Temple Place - Suite 330, --
-- Boston, MA 02111-1307, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
--               GLADE  is maintained by ACT Europe.                        --
--               (email: glade-report@act-europe.fr)                        --
--                                                                          --
------------------------------------------------------------------------------
with Ada.Text_IO; use Ada.Text_IO;  --  jl  pl

package body System.Garlic.Protocols is



   --  (I)jl  pl (LOCATION)----------------------------
   function Busca_Dospuntos (Texto : in String; Inicio : in Integer)
                            return Integer;
   function Lookup_Protocol (P : String) return Protocol_Access;



   function Busca_Dospuntos (Texto : in String; Inicio : in Integer)
                            return Integer is
   begin
      for I in Inicio .. Texto'Length loop
         if Texto (I) = ':' then
            return I;
         end if;
      end loop;
      --  Put_Line ("No :");
      return 0;
   end Busca_Dospuntos;
   MAX_TEXTO : constant Integer := 100;

   function Lookup_Protocol (P : String) return Protocol_Access is
   begin
      for I in First_Protocol .. Last_Protocol loop
         if Get_Name (Protocol_Table (I)) = P then
            return Protocol_Table (I);
         end if;
      end loop;
      return null;
   end Lookup_Protocol;

   type Full_Texto_Type is record
      Data_Str : String (1 .. MAX_TEXTO);
      Data_Len : Integer := 0;
   end record;
   type Partition_Name_Type is array (1 .. MAX_PARTI) of Full_Texto_Type;
   type Linea_Loc_Type is array (1 .. MAX_PARTI) of Mi_Location_Type;
   type Linea_Pro_Type is array (1 .. MAX_PARTI) of Protocol_Access;
   Linea_Locations_INC : Linea_Loc_Type;
   Linea_Locations_OUT : Linea_Loc_Type;
   P_Name : Partition_Name_Type;
   Linea_Protocols : Linea_Pro_Type;
   ------------------------------

   procedure Set_Partition_Links_INC (Number : in Integer;
                                  Name : in String; Data : in String) is
   begin
      Linea_Locations_INC (Number).Data_Str (1 .. Data'Length) := Data;
      Linea_Locations_INC (Number).Data_Len := Data'Length;

      P_Name (Number).Data_Str (1 .. Name'Length) := Name;
      P_Name (Number).Data_Len := Name'Length;

      Put_Line (Number'Img & "---" &  Name & "---"  & Data);
   end Set_Partition_Links_INC;


   function Read_Partition_Links_INC_PRO (Num : in Integer)
                                         return Protocol_Access is
      Prot_Str : String (1 .. 30);
      Prot_Len : Integer := 0;
      Tam : Integer;
   begin
--      Put_Line ("---  (I) Partition_Links ---------");
      Tam := Linea_Locations_INC (Num).Data_Len;
      if Tam = 0 then
--         Put_Line ("Read_Partition_Links_INC: En PID= " & Num'Img &
--                   " NO HAY NADA");
         return null;
      end if;
      Prot_Len := Busca_Dospuntos (
                         Linea_Locations_INC (Num).Data_Str (1 .. Tam),
                         1) - 1;  --  pq devuelve i=pos(:)
      Prot_Str (1 .. Prot_Len) := Linea_Locations_INC (Num).
                   Data_Str (1 .. Prot_Len);
--      Put_Line (Prot_Str (1 .. Prot_Len));
      Linea_Protocols (Num) :=
        Lookup_Protocol (Prot_Str (1 .. Prot_Len));

--      Put_Line (Linea_Locations_INC (Num).Data_Str (1 .. Tam));
--      Put_Line (Get_Name  (Linea_Protocols (Num)));
--      Put_Line ("---  (F) Partition_Links ---------");
      return Linea_Protocols (Num);
   end Read_Partition_Links_INC_PRO;


   function Read_Partition_Links_INC_LOC_DATA (Num : in Integer)
                                          return String  is
      Prim_Dospuntos : Integer := 0;
      Devuelvo : String (1 .. 50);
   begin

      Prim_Dospuntos := Busca_Dospuntos (Linea_Locations_INC (Num).
                       Data_Str (1 .. Linea_Locations_INC (Num).Data_Len), 1);
      Devuelvo (1 .. Linea_Locations_INC (Num).Data_Len - Prim_Dospuntos - 2)
        := Linea_Locations_INC (Num).Data_Str (Prim_Dospuntos + 3 ..
                              Linea_Locations_INC (Num).Data_Len);
      return  Devuelvo (1 .. Linea_Locations_INC (Num).Data_Len
                        - Prim_Dospuntos - 2);
   end Read_Partition_Links_INC_LOC_DATA;


   --  /////////////////////////////////////////////////////////////////
   --  /////////////////////////////////////////////////////////////////
   --  /////////////////////////////////////////////////////////////////
   --  /////////////////////////////////////////////////////////////////
   --  De los outcomings (hacia donde voy a salir mandando)
   procedure Set_Partition_Links_OUT (Number : in Integer;
                                      Name : in String; Data : in String) is
   begin
      Linea_Locations_OUT (Number).Data_Str (1 .. Data'Length) := Data;
      Linea_Locations_OUT (Number).Data_Len := Data'Length;

      P_Name (Number).Data_Str (1 .. Name'Length) := Name;
      P_Name (Number).Data_Len := Name'Length;

      Put_Line (Number'Img & "---" &  Name & "---"  & Data);
   end Set_Partition_Links_OUT;


   function Read_Partition_Links_OUT_PRO (Num : in Integer)
                                         return Protocol_Access is
      Prot_Str : String (1 .. 30);
      Prot_Len : Integer := 0;
      Tam : Integer;
   begin

--      Put_Line ("---  (I) Partition_Links ---------");
      Tam := Linea_Locations_OUT (Num).Data_Len;
      if Tam = 0 then
--         Put_Line ("Read_Partition_Links_OUT: En PID= " & Num'Img &
--                   " NO HAY NADA");
         return null;
      end if;
      Prot_Len := Busca_Dospuntos (
                         Linea_Locations_OUT (Num).Data_Str (1 .. Tam),
                         1) - 1;  --  pq devuelve i=pos(:)
      Prot_Str (1 .. Prot_Len) := Linea_Locations_OUT (Num).
                   Data_Str (1 .. Prot_Len);
--      Put_Line (Prot_Str (1 .. Prot_Len));
      Linea_Protocols (Num) :=
        Lookup_Protocol (Prot_Str (1 .. Prot_Len));

      return Linea_Protocols (Num);
   end Read_Partition_Links_OUT_PRO;


   function Read_Partition_Links_OUT_LOC_DATA (Num : in Integer)
                                              return String is
      Prim_Dospuntos : Integer := 0;
      Devuelvo : String (1 .. 50);
   begin

      Prim_Dospuntos := Busca_Dospuntos (Linea_Locations_OUT (Num).
                       Data_Str (1 .. Linea_Locations_OUT (Num).Data_Len), 1);
      Devuelvo (1 .. Linea_Locations_OUT (Num).Data_Len - Prim_Dospuntos - 2)
        := Linea_Locations_OUT (Num).Data_Str (Prim_Dospuntos + 3 ..
                              Linea_Locations_OUT (Num).Data_Len);
      return  Devuelvo (1 .. Linea_Locations_OUT (Num).Data_Len
                        - Prim_Dospuntos - 2);

   end Read_Partition_Links_OUT_LOC_DATA;

   --  (F)  jl pl SET/READ (LOCATION)-------------------------



   --------------
   -- Get_Data --
   --------------

   function Get_Data
     (Protocol  : access Protocol_Type)
     return Utils.String_Array_Access
   is
      pragma Unreferenced (Protocol);
   begin
      return null;
   end Get_Data;

   --------------------------------
   -- Receive_From_All_Protocols --
   --------------------------------

   procedure Receive_From_All_Protocols
   is
      Timeout  : Duration := Polling;
      Protocol : Natural  := First_Protocol;

   begin
      if First_Protocol = Last_Protocol then
         Timeout := Forever;
      end if;
      loop
         exit when Receive (Protocol_Table (Protocol), Timeout);
         if Protocol = Last_Protocol then
            Protocol := First_Protocol;
         else
            Protocol := Protocol + 1;
         end if;
      end loop;
   end Receive_From_All_Protocols;

   --------------
   -- Register --
   --------------

   procedure Register (Protocol : in Protocol_Access) is
   begin
      if Protocol = null then
         return;
      end if;
      Last_Protocol := Last_Protocol + 1;
      Protocol_Table (Last_Protocol) := Protocol;
   end Register;

   --------------
   -- Shutdown --
   --------------

   procedure Shutdown is
   begin
      for I in First_Protocol .. Last_Protocol loop
         Shutdown (Protocol_Table (I));
      end loop;
   end Shutdown;

end System.Garlic.Protocols;

