------------------------------------------------------------------------------
--                                                                          --
--                            GLADE COMPONENTS                              --
--                                                                          --
--                 S Y S T E M . G A R L I C . R E M O T E                  --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--                            $Revision: 1.5 $
--                                                                          --
--         Copyright (C) 1996-2001 Free Software Foundation, Inc.           --
--                                                                          --
-- GARLIC is free software;  you can redistribute it and/or modify it under --
-- terms of the  GNU General Public License  as published by the Free Soft- --
-- ware Foundation;  either version 2,  or (at your option)  any later ver- --
-- sion.  GARLIC is distributed  in the hope that  it will be  useful,  but --
-- WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHANTABI- --
-- LITY or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public  --
-- License  for more details.  You should have received  a copy of the GNU  --
-- General Public License  distributed with GARLIC;  see file COPYING.  If  --
-- not, write to the Free Software Foundation, 59 Temple Place - Suite 330, --
-- Boston, MA 02111-1307, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
--               GLADE  is maintained by ACT Europe.                        --
--               (email: glade-report@act-europe.fr)                        --
--                                                                          --
------------------------------------------------------------------------------

--  jl with Ada.Unchecked_Deallocation;

--  jl with GNAT.IO;
--  jl with GNAT.Sockets;                    use GNAT.Sockets;

--  jl with Interfaces.C;                    use Interfaces.C;

--  jl with System.Garlic.Debug;             use System.Garlic.Debug;
--  jl with System.Garlic.Options;
--  jl with System.Garlic.Partitions;        use System.Garlic.Partitions;
--  jl with System.Garlic.Utils;             use System.Garlic.Utils;

package body System.Garlic.Remote is

--  jl    package C renames Interfaces.C;
--  jl    --  Shortcuts

--  jl   Private_Debug_Key : constant Debug_Key :=
--  jl     Debug_Initialize ("S_GARREM", "(s-garrem): ");

--  jl   procedure D
--  jl     (Message : in String;
--  jl      Key     : in Debug_Key := Private_Debug_Key)
--  jl     renames Print_Debug_Info;

--  jl    procedure C_Dup2
--  jl      (Fd1, Fd2 : in C.int);
--  jl    pragma Import (C, C_Dup2, "dup2");

--  jl    function C_Open
--  jl      (Path  : C.char_array;
--  jl       Oflag : C.int;
--  jl       Mode  : C.int := 0)
--  jl      return C.int;
--  jl    pragma Import (C, C_Open, "open");

--  jl    procedure C_Setsid;
--  jl    pragma Import (C, C_Setsid, "setsid");
--  jl
--  jl    function C_System (Command : System.Address) return C.int;
--  jl    pragma Import (C, C_System, "system");

--  jl   function Is_Local_Host (Host : String) return Boolean;
   --  Return True if the Host we are trying to contact is the same as the
   --  local host.

--  jl   procedure Spawn (Command : in String);

--  jl    type Partition_Info;
--  jl    type Partition_List is access Partition_Info;
--  jl
--  jl    type Partition_Info is record
--  jl       Remote_Host  : String_Access;
--  jl       Command_Line : String_Access;
--  jl       Next         : Partition_List;
--  jl    end record;

--  jl    procedure Free is
--  jl       new Ada.Unchecked_Deallocation (Partition_Info, Partition_List);

--  jl    List : Partition_List;


   ------------
   -- Detach --
   ------------

   procedure Detach is
--  jl       Dev_Null      : C.int;
--  jl       Dev_Null_Name : constant C.char_array := To_C ("/dev/null");
   begin
--  jl       if Options.Detach then
--  jl          Dev_Null := C_Open (Dev_Null_Name, 2);
--  jl          C_Dup2 (Dev_Null, 0);
--  jl          C_Dup2 (Dev_Null, 1);
--  jl          C_Dup2 (Dev_Null, 2);
--  jl          C_Setsid;
--  jl       end if;
      null;  --  jl
   end Detach;

   -----------------
   -- Full_Launch --
   -----------------

   procedure Full_Launch
     (Host        : in String;
      Command     : in String)
   is
--  jl      Arguments : constant String :=
--  jl        "--detach --boot_location '" & Get_Boot_Locations & "' &";
   begin
--  jl      if System.Garlic.Options.Local_Launch
--  jl        and then Host (Host'First) /= '`'
--  jl        and then Is_Local_Host (Host)
--  jl      then
--  jl         declare
--  jl            C1 : constant String := Quote (Command) & ' ' & Arguments;
--  jl--  jl
--  jl         begin
--  jl            pragma Debug (D ("Run Spawn: " & C1));
--  jl--  jl
--  jl            Spawn (C1);
--  jl         end;
--  jl
--  jl      else
--  jl         declare
--  jl            C1 : constant String := Command;
--  jl            C2 : constant String := Quote (C1 & ' ' & Arguments);
--  jl            C3 : constant String := Host & ' ' & Options.Rsh_Options.all;
--  jl            C4 : constant String := Options.Rsh_Command.all & ' ' & C3;
--  jl            C5 : constant String := C4 & ' ' & C2;
--  jl            C6 : constant String := C5 & " < /dev/null > /dev/null 2>&1";

--  jl         begin
--  jl            pragma Debug (D ("Enter Spawn: " & C6));

--  jl            Spawn (C6);

--  jl            pragma Debug (D ("Leave Spawn: " & C6));
--  jl         end;
--  jl      end if;
      null;  --  jl
   end Full_Launch;

   --------------
   -- Get_Host --
   --------------

   function Get_Host
     (Partition : String)
     return String
   is
--  jl      Buffer : String (1 .. 64);
--  jl      Last   : Natural;
   begin
--  jl      GNAT.IO.Put ("Host for """ & Partition & """: ");
--  jl      GNAT.IO.Get_Line (Buffer, Last);
--  jl      return Buffer (1 .. Last);
      return " ";  --  jl
   end Get_Host;

   -------------------
   -- Is_Local_Host --
   -------------------

--  jl   function Is_Local_Host
--  jl     (Host : String)
--  jl     return Boolean
--  jl   is
--  jl       Name_Of_Host : constant String
--  jl          := Official_Name (Get_Host_By_Name (Host));
--  jl   begin
--  jl        return Host = "localhost"
--  jl          or else Name_Of_Host = "localhost"
--  jl     or else Name_Of_Host = Official_Name (Get_Host_By_Name (Host_Name));
--  jl      return True;  --  jl
--  jl   end Is_Local_Host;

   ----------------------------------
   -- Launch_Registered_Partitions --
   ----------------------------------

   procedure Launch_Registered_Partitions
   is
--  jl        P : Partition_List;

   begin
--  jl        if Options.Nolaunch then
--  jl           return;
--  jl        end if;

--  jl        while List /= null loop
--  jl           P    := List;
--  jl           List := List.Next;
--  jl
--  jl           Full_Launch
--  jl             (P.Remote_Host.all,
--  jl              P.Command_Line.all);
--  jl
--  jl           Destroy (P.Remote_Host);
--  jl           Destroy (P.Command_Line);
--  jl           Free (P);
--  jl        end loop;
      null;  --  jl
   end Launch_Registered_Partitions;

   ----------------------------------
   -- Register_Partition_To_Launch --
   ----------------------------------

   procedure Register_Partition_To_Launch
     (Name_Is_Host : in Boolean;
      General_Name : in String;
      Command_Line : in String)
   is
--  jl        P : Partition_List;

   begin
--  jl        P := new Partition_Info;
--  jl        P.Command_Line := new String'(Command_Line);
--  jl        if Name_Is_Host then
--  jl           P.Remote_Host := new String'(General_Name);
--  jl        else
--  jl           P.Remote_Host := new String'(Get_Host (General_Name));
--  jl        end if;
--  jl        P.Next := List;
--  jl        List   := P;
      null;  --  jl
   end Register_Partition_To_Launch;

   -----------
   -- Spawn --
   -----------

--  jl   procedure Spawn (Command : in String)
--  jl   is
--  jl        C_Command : aliased String := Command & ASCII.NUL;
--  jl   begin
--  jl        if C_System (C_Command'Address) / 256 /= 0 then
--  jl           raise Program_Error;
--  jl        end if;
--  jl      null;  --  jl
--  jl   end Spawn;

end System.Garlic.Remote;
