------------------------------------------------------------------------------
--                                                                          --
--                            GLADE COMPONENTS                              --
--                                                                          --
--                  S Y S T E M . G A R L I C . T R A C E                   --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--                            $Revision: 1.24 $
--                                                                          --
--         Copyright (C) 1996-2001 Free Software Foundation, Inc.           --
--                                                                          --
-- GARLIC is free software;  you can redistribute it and/or modify it under --
-- terms of the  GNU General Public License  as published by the Free Soft- --
-- ware Foundation;  either version 2,  or (at your option)  any later ver- --
-- sion.  GARLIC is distributed  in the hope that  it will be  useful,  but --
-- WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHANTABI- --
-- LITY or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public  --
-- License  for more details.  You should have received  a copy of the GNU  --
-- General Public License  distributed with GARLIC;  see file COPYING.  If  --
-- not, write to the Free Software Foundation, 59 Temple Place - Suite 330, --
-- Boston, MA 02111-1307, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
--               GLADE  is maintained by ACT Europe.                        --
--               (email: glade-report@act-europe.fr)                        --
--                                                                          --
------------------------------------------------------------------------------

--  jl  with Ada.Streams.Stream_IO; use Ada.Streams.Stream_IO;

--  jl  with Ada.Calendar;          use Ada.Calendar;
--  jl  with System.Garlic.Options; use System.Garlic.Options;
--  jl  with System.Garlic.Debug;   use System.Garlic.Debug;

package body System.Garlic.Trace is

--  jl   Private_Debug_Key : constant Debug_Key :=
--  jl     Debug_Initialize ("S_GARTRA", "(s-gartra): ");
--  jl   procedure D
--  jl     (Message : in String;
--  jl      Key     : in Debug_Key := Private_Debug_Key)
--  jl     renames Print_Debug_Info;

   use Ada.Streams;
--  jl     use System.Garlic.Streams;
   use System.Garlic.Types;

--  jl     Trace_File : File_Type;
--  jl     --  File containing the traces

--  jl     Trace_Start : Time;
--  jl     --  Date of the first trace

   ----------------
   -- Initialize --
   ----------------
--  jl  VACIO
   procedure Initialize is
   begin
--  jl        pragma Debug
--  jl       (D ("Initializing trace / replay in mode " & Execution_Mode'Img));

--  jl        if Execution_Mode = Trace_Mode then
--  jl           Trace_Start := Clock;

--  jl         pragma Debug (D ("Creating trace file " & Trace_File_Name.all));
--  jl              Create (Trace_File, Out_File, Trace_File_Name.all);
--  jl        end if;
      null;  --  jl
   end Initialize;

   ----------
   -- Read --
   ----------

   procedure Read
     (S : access Root_Stream_Type'Class;
      T : out Trace_Type)
   is
--  jl        Count : Stream_Element_Count;

   begin
--  jl        Duration'Read (S, T.Time);
--  jl        Stream_Element_Count'Read (S, Count);
--  jl        T.Data := new Stream_Element_Array (1 .. Count);
--  jl        for I in T.Data'Range loop
--  jl           Stream_Element'Read (S, T.Data (I));
--  jl        end loop;
--  jl        Partition_ID'Read (S, T.PID);
      T.PID := Types.Null_PID;  --  jl
      null;  --  jl
   end Read;

   --------------
   -- Shutdown --
   --------------

   procedure Shutdown is
   begin
--  jl        if Execution_Mode = Trace_Mode
--  jl          and then Is_Open (Trace_File)
--  jl        then
--  jl           pragma Debug (D ("Closing trace file"));
--  jl           Close (Trace_File);
--  jl        end if;
      null;  --  jl
   end Shutdown;

   -------------------------
   -- Trace_Received_Data --
   -------------------------

   procedure Trace_Received_Data
     (Partition : in Types.Partition_ID;
      Filtered  : access Ada.Streams.Stream_Element_Array;
      Offset    : in  Ada.Streams.Stream_Element_Count)
   is
--  jl        Trace : Trace_Type;
--  jl        First : constant Stream_Element_Count := Filtered'First + Offset;
--  jl        Last  : constant Stream_Element_Count := Filtered'Last;

   begin
      --  Compute the period between the arrival of this message and
      --  the arrival of the previous message.

--  jl        Trace.Time := Clock - Trace_Start;

--  jl        Trace.Data     := new Stream_Element_Array (First .. Last);
--  jl        Trace.Data.all := Filtered (First .. Last);
--  jl        Trace.PID      := Partition;

--  jl        pragma Debug
--  jl          (D ("Writing trace from partition" & Trace.PID'Img &
--  jl              " of length" & Trace.Data'Length'Img));

--  jl        Trace_Type'Output (Stream (Trace_File), Trace);
--  jl        Free (Trace.Data);
      null;  --  jl
   end Trace_Received_Data;

   -----------
   -- Write --
   -----------

   procedure Write
     (S : access Root_Stream_Type'Class;
      T : in Trace_Type)
   is
   begin
--  jl        pragma Assert (T.Data /= null);
--  jl        Duration'Write (S, T.Time);
--  jl        Stream_Element_Count'Write (S, T.Data'Length);
--  jl        for I in T.Data'Range loop
--  jl           Stream_Element'Write (S, T.Data (I));
--  jl        end loop;
--  jl        Partition_ID'Write (S, T.PID);
      null;  --  jl
   end Write;

end System.Garlic.Trace;




