------------------------------------------------------------------------------
--                                                                          --
--                            GLADE COMPONENTS                              --
--                                                                          --
--           S Y S T E M . G A R L I C . S T O R A G E S . D F S            --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--                            $Revision: 1.6 $
--                                                                          --
--         Copyright (C) 1996-2001 Free Software Foundation, Inc.           --
--                                                                          --
-- GARLIC is free software;  you can redistribute it and/or modify it under --
-- terms of the  GNU General Public License  as published by the Free Soft- --
-- ware Foundation;  either version 2,  or (at your option)  any later ver- --
-- sion.  GARLIC is distributed  in the hope that  it will be  useful,  but --
-- WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHANTABI- --
-- LITY or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public  --
-- License  for more details.  You should have received  a copy of the GNU  --
-- General Public License  distributed with GARLIC;  see file COPYING.  If  --
-- not, write to the Free Software Foundation, 59 Temple Place - Suite 330, --
-- Boston, MA 02111-1307, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
--               GLADE  is maintained by ACT Europe.                        --
--               (email: glade-report@act-europe.fr)                        --
--                                                                          --
------------------------------------------------------------------------------

--  jl  with Ada.IO_Exceptions;
--  jl  with Ada.Unchecked_Conversion;

--  jl  with GNAT.OS_Lib; use GNAT.OS_Lib;

with System;
--  jl  with System.File_Control_Block;
--  jl  with System.File_IO;

--  jl  with System.Garlic.Debug; use System.Garlic.Debug;
--  jl  pragma Elaborate (System.Garlic.Debug);

--  jl  with System.Garlic.Physical_Location;
--  jl  use  System.Garlic.Physical_Location;

--  jl  with System.Garlic.Options;    use System.Garlic.Options;
--  jl  with System.Garlic.Soft_Links; use System.Garlic.Soft_Links;
--  jl  with System.Garlic.Utils;      use System.Garlic.Utils;

package body System.Garlic.Storages.Dfs is

--  jl     Private_Debug_Key : constant Debug_Key :=
--  jl       Debug_Initialize ("S_GASTDF", "(s-gastdf): ");

--  jl     Dfs_Storage_Name : constant String := "dfs";

--  jl     procedure D
--  jl       (Message : in String;
--  jl        Key     : in Debug_Key := Private_Debug_Key)
--  jl       renames Print_Debug_Info;

--  jl     use type SIO.File_Mode;
--  jl     use type System.Global_Locks.Lock_Type;

--  jl     package IOX renames Ada.IO_Exceptions;

--  jl     package FCB renames System.File_Control_Block;

--  jl     package SFI renames System.File_IO;

--  jl     function To_AFCB_Ptr is
--  jl        new Ada.Unchecked_Conversion (SIO.File_Type, FCB.AFCB_Ptr);

--  jl     Sep : Character renames OS.Directory_Separator;

--  jl     Root : DFS_Data_Access;

--  jl     LRU_Head : DFS_Data_Access;
--  jl     LRU_Tail : DFS_Data_Access;

   ----------------------------------------------
   -- Variables for Shared Memory Access Files --
   ----------------------------------------------

--  jl     Max_Shared_Files_Open : constant := 20;
--  jl     --  Maximum number of lock files that can be open

--  jl     Shared_Files_Open : Natural := 0;
--  jl     --  Number of shared memory access files currently open

--  jl     To_File_Mode : constant array (Read .. Write) of SIO.File_Mode
--  jl       := (Read => SIO.In_File, Write => SIO.Out_File);

--  jl     function  Lock_Name (Var_Data : DFS_Data_Type) return String;

   ----------------------
   -- Complete_Request --
   ----------------------

   procedure Complete_Request
     (Var_Data : in out DFS_Data_Type) is
   begin
--  jl        if Var_Data.Count > 0 then
--  jl           Var_Data.Count := Var_Data.Count - 1;

--  jl           if Var_Data.Count = 0 then
--  jl              SGL.Release_Lock (Var_Data.Lock);
--  jl           end if;
--  jl
--  jl           pragma Debug (D ("lock count =" & Var_Data.Count'Img));
--  jl        end if;

--  jl        Leave (Var_Data.Mutex);
      null;  --  jl
   end Complete_Request;

   --------------------
   -- Create_Package --
   --------------------

   procedure Create_Package
     (Storage  : in out DFS_Data_Type;
      Pkg_Name : in     String;
      Pkg_Data : in out    Shared_Data_Access)  --  jl in
   is
--  jl        Result : DFS_Data_Access;

   begin
--  jl        pragma Debug (D ("create package file " & Pkg_Name &
--  jl                         " on support " & Storage.Dir.all));

--  jl        Result      := new DFS_Data_Type;
--  jl        Result.Name := new String'(Pkg_Name);
--  jl        Result.Dir  := Storage.Dir;
--  jl        Pkg_Data    := Shared_Data_Access (Result);
      null;  --  jl
   end Create_Package;

   --------------------
   -- Create_Storage --
   --------------------

   procedure Create_Storage
     (Master   : in out DFS_Data_Type;
      Location : in     String;
      Storage  : in out    Shared_Data_Access)
   is
      pragma Unreferenced (Master);

--  jl        Result   : DFS_Data_Access;

   begin
--  jl        Result := new DFS_Data_Type;

--  jl        --  Location is a directory. Add a separator if the location is
--  jl        --  not empty.

--  jl        if Location'Length /= 0 then
--  jl           Result.Dir := new String'(Location & Sep);
--  jl        else
--  jl           Result.Dir := new String'(Location);
--  jl        end if;

--  jl        pragma Debug
--  jl          (D ("create storage dfs with """ & Result.Dir.all & """"));

--  jl        Storage := Shared_Data_Access (Result);
      null;  --  jl
   end Create_Storage;

   ---------------------
   -- Create_Variable --
   ---------------------

   procedure Create_Variable
     (Pkg_Data : in out DFS_Data_Type;
      Var_Name : in     String;
      Var_Data : in out    Shared_Data_Access)
   is
--  jl        Var : DFS_Data_Access := new DFS_Data_Type;

   begin
--  jl        pragma Debug (D ("create variable file " & Var_Name &
--  jl                         " for package file " & Pkg_Data.Name.all));

--  jl        Var.Name  := new String'(Var_Name);
--  jl        Var.Self  := Var;
--  jl        Var.Count := 0;
--  jl        Var.Dir   := Pkg_Data.Dir;
--  jl        Create (Var.Mutex);
--  jl        Var.Lock  := SGL.Null_Lock;
--  jl        Var_Data  := Shared_Data_Access (Var);
      null;  --  jl
   end Create_Variable;

   ----------------
   -- Initialize --
   ----------------

   procedure Initialize
   is
--  jl        Data_Dir : OS.String_Access;

   begin
--  jl        pragma Debug (D ("initialize DFS"));

--  jl        if Root = null then
--  jl           Root := new DFS_Data_Type;
--  jl           if Data_Location /= null
--  jl   and then Get_Support_Name (Data_Location (1).all) = Dfs_Storage_Name
--  jl           then
--  jl      Data_Dir := new String'(Get_Support_Data (Data_Location (1).all));
--  jl           end if;
--  jl           if Data_Dir = null then
--  jl              Data_Dir := OS.Getenv ("DFS_DATA_DIR");
--  jl           end if;
--  jl           if Data_Dir'Length = 0 then
--  jl              Root.Dir := new String'(Data_Dir.all);
--  jl           else
--  jl              Root.Dir := new String'(Data_Dir.all & Sep);
--  jl           end if;
--  jl           Free (Data_Dir);
--  jl         pragma Debug (D ("root data name is """ & Root.Dir.all & """"));
--  jl         Register_Storage (Dfs_Storage_Name, Shared_Data_Access (Root));
--  jl        end if;
      null;  --  jl
   end Initialize;

   ----------------------
   -- Initiate_Request --
   ----------------------

   procedure Initiate_Request
     (Var_Data : in out DFS_Data_Type;
      Request  : in Request_Type;
      Success  : out Boolean)
   is
--  jl        Done : Boolean := True;
--  jl        Free : DFS_Data_Access;

   begin
--  jl        Enter (Var_Data.Mutex);
--  jl        case Request is
--  jl           when Read | Write =>
--  jl              declare
--  jl        Fname : constant String := Var_Data.Dir.all & Var_Data.Name.all;
--  jl                 Fmode : SIO.File_Mode   := To_File_Mode (Request);
--  jl
--  jl              begin
--  jl                 if not SIO.Is_Open (Var_Data.File) then
--  jl                    begin
--  jl                       SIO.Open (Var_Data.File, Fmode, Name => Fname);
--  jl                       SFI.Make_Unbuffered (To_AFCB_Ptr (Var_Data.File));
--  jl
--  jl                       pragma Debug (D ("open variable file " & Fname));
--  jl
--  jl                    exception
--  jl                       when IOX.Name_Error =>
--  jl
--  jl                          if Request = Read then
--  jl                             Leave (Var_Data.Mutex);
--  jl                             Done := False;
--  jl
--  jl                          else
--  jl                       SIO.Create (Var_Data.File, Fmode, Name => Fname);
--  jl                     pragma Debug (D ("create variable file " & Fname));
--  jl  --  jl                          end if;
--  jl                    end;
--  jl
--  jl                    if Done then
--  jl                       Enter_Critical_Section;
--  jl                       Shared_Files_Open := Shared_Files_Open + 1;
--  jl  --  jl
--  jl                       if Shared_Files_Open = Max_Shared_Files_Open then
--  jl                          Free := LRU_Head;
--  jl
--  jl                          if Free.Next /= null then
--  jl                             Free.Next.Prev := null;
--  jl                          end if;
--  jl
--  jl                          LRU_Head  := Free.Next;
--  jl                          Free.Next := null;
--  jl                          Free.Prev := null;
--  jl                          SIO.Close (Free.File);
--  jl                          pragma Debug
--  jl                            (D ("close variable file " & Free.Name.all));
--  jl  --  jl                       end if;
--  jl
--  jl                       --  Add new entry at end of LRU chain
--  jl
--  jl  --  jl                       if LRU_Head = null then
--  jl                          LRU_Head := Var_Data.Self;
--  jl                          LRU_Tail := Var_Data.Self;
--  jl  --  jl
--  jl                       else
--  jl                          Var_Data.Prev := LRU_Tail;
--  jl                          LRU_Tail.Next := Var_Data.Self;
--  jl                          LRU_Tail      := Var_Data.Self;
--  jl                       end if;
--  jl                       Leave_Critical_Section;
--  jl                    end if;
--  jl
--  jl                   --  Here if file is already open, set file for reading
--  jl
--  jl                 else
--  jl                    if SIO.Mode (Var_Data.File) /= Fmode then
--  jl                       pragma Debug
--  jl                         (D ("reset variable file " &
--  jl                             Var_Data.Name.all &
--  jl                             " mode to " & Request'Img));
--  jl
--  jl  --  jl                       SIO.Set_Mode (Var_Data.File, Fmode);
--  jl                       SFI.Make_Unbuffered (To_AFCB_Ptr (Var_Data.File));
--  jl  --  jl                    end if;
--  jl
--  jl                   SIO.Set_Index (Var_Data.File, 1);
--  jl                 end if;
--  jl              end;
--  jl
--  jl           when Lock =>
--  jl              Var_Data.Count := Var_Data.Count + 1;
--  jl              if Var_Data.Lock = SGL.Null_Lock then
--  jl                 SGL.Create_Lock (Var_Data.Lock, Lock_Name (Var_Data));
--  jl              end if;
--  jl              if Var_Data.Count = 1 then
--  jl                 SGL.Acquire_Lock (Var_Data.Lock);
--  jl              end if;

--  jl              pragma Debug (D ("lock count =" & Var_Data.Count'Img));
--  jl
--  jl        end case;
--  jl         Success := Done;

      Success := True;  --  jl
      null;  --  jl

   end Initiate_Request;

   ---------------
   -- Lock_Name --
   ---------------

--  jl   function Lock_Name (Var_Data : DFS_Data_Type) return String is
--  jl   begin
--  jl         return Var_Data.Dir.all & ".entry";
--  jl      return " ";  --  jl
--  jl   end Lock_Name;

   ----------
   -- Read --
   ----------

   procedure Read
     (Data : in out DFS_Data_Type;
      Item : in out Ada.Streams.Stream_Element_Array;  --  jl in
      Last : in out Ada.Streams.Stream_Element_Offset) is  --  jl in
   begin
--  jl        pragma Debug (D ("read variable file " & Data.Name.all));

--  jl        SIO.Read (Data.File, Item, Last);
--  jl     exception when others =>
--  jl        Last := Item'Last;
      null;  --  jl
   end Read;

   -----------
   -- Write --
   -----------

   procedure Write
     (Data : in out DFS_Data_Type;
      Item : in Ada.Streams.Stream_Element_Array) is
   begin
--  jl        pragma Debug (D ("write variable file " & Data.Name.all));

--  jl        SIO.Write (Data.File, Item);
--  jl     exception when others =>
--  jl        null;
      null;  --  jl
   end Write;

end System.Garlic.Storages.Dfs;
