----------------------------------------------------------------------------
-------------------------      M a R T E   O S      ------------------------
----------------------------------------------------------------------------
--                                                            {MARTE_VERSION}
--
--                          'e t h e r n e t . a d s'
--
--                                     C
--
--
-- File 'ethernet.ads'                                                By Chema.
--                                                          Jose Maria Martinez
--                                                         <martinjm@unican.es>
-- Import functions of ethernet.h
--
--
--{MARTE_COPYRIGHT}
--
-----------------------------------------------------------------------------


with Drivers_MaRTE;  use Drivers_MaRTE;
with System, Ada.Unchecked_Conversion;

package Ethernet is

   --  Create
   function Create (Create_Arg : in Int) return Int;
   pragma Import (C, Create, "eth_create");
   function Address_To_Create_Ac is
      new Ada.Unchecked_Conversion (System.Address, Create_Function_Ac);
   Create_Ac : Create_Function_Ac := Address_To_Create_Ac (Create'Address);

   --  Open
   function Open (Fd   : in File_Descriptor;
                  Mode : in File_Access_Mode) return Int;
   pragma Import (C, Open, "eth_open");
   function Address_To_Open_Ac is
      new Ada.Unchecked_Conversion (System.Address, Open_Function_Ac);
   Open_Ac : Open_Function_Ac := Address_To_Open_Ac (Open'Address);


   --  Close
   function Close (Fd : in File_Descriptor)return Int;
   pragma Import (C, Close, "eth_close");
   function Address_To_Close_Ac is
      new Ada.Unchecked_Conversion (System.Address, Close_Function_Ac);
   Close_Ac : Close_Function_Ac := Address_To_Close_Ac (Close'Address);


     --  Read
   function Read (Fd         : in File_Descriptor;
                  Buffer_Ptr : in Buffer_Ac;
                  Bytes      : in Buffer_Length) return Int;
   pragma Import (C, Read, "eth_read");
   function Address_To_Read_Ac is
      new Ada.Unchecked_Conversion (System.Address, Read_Function_Ac);
   Read_Ac : Read_Function_Ac := Address_To_Read_Ac (Read'Address);


   --  Write
   function Write (Fd         : in File_Descriptor;
                   Buffer_Ptr : in Buffer_Ac;
                   Bytes      : in Buffer_Length) return Int;
   pragma Import (C, Write, "eth_write");
   function Address_To_Write_Ac is
      new Ada.Unchecked_Conversion (System.Address, Write_Function_Ac);
   Write_Ac : Write_Function_Ac := Address_To_Write_Ac (Write'Address);

   --  Ioctl
   function Ioctl (Fd             : in File_Descriptor;
                   Request        : in Ioctl_Option_Value;
                   Ioctl_Data_Ptr : in Buffer_Ac) return Int;
   pragma Import (C, Ioctl, "eth_ioctl");
   function Address_To_Ioctl_Ac is
      new Ada.Unchecked_Conversion (System.Address, Ioctl_Function_Ac);
   Ioctl_Ac : Ioctl_Function_Ac := Address_To_Ioctl_Ac (Ioctl'Address);


end Ethernet;
