/*----------------------------------------------------------------------------
 *-------------------------      M a R T E   O S      ------------------------
 *----------------------------------------------------------------------------
 *                                                             {MARTE_VERSION}
 *
 *                                'n i c . h'
 *
 *                                     C
 *
 *
 * File 'nic.h'                                                       By Chema.
 *                                                          Jose Maria Martinez
 * Ethernet basic driver definitions 
 *
 * {MARTE_COPYRIGHT}
 *
 *---------------------------------------------------------------------------*/
/* {<MAR}
 * Chema:
 * Date format DD-MM-YY:
 *
 *
 * 16-12-02: Total re-make to be similar to the nic.h on Etherboot
 *
 * 26-11-02: First draft.
 *
 *
 * {MAR>} -------------------------------------------------------------------*/
/*****************************************************************************/
/* Most of this module is taken from the Etherboot proyect:                  */
/* http://etherboot.sourceforge.net v.5.1.3                                  */



 /*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.
 */

#ifndef	NIC_H
#define NIC_H

#include "dev.h"

/*
 *	Structure returned from eth_probe and passed to other driver
 *	functions.
 */
struct nic
{
  struct dev	dev;  /* This must come first */
  int		(*poll)(struct nic *);
  void		(*transmit)(struct nic *, const char *d,
				unsigned int t, unsigned int s, const char *p);
  int (*handler)(void); // Interrups handler.
  int (*open)(struct nic *); //open function.
  int		flags;	/* driver specific flags */

  
  struct rom_info	*rom_info;	/* -> rom_info from main */
  unsigned char	*node_addr;
  unsigned char	*packet;
  unsigned int	packetlen;
  unsigned char irq; /* Assigned IRQ values (0 - 15)*/
  void		*priv_data;	/* driver can hang private data here */
};


extern struct nic nic;

#endif	/* NIC_H */
