#ifndef _ETH_IOCTL_H_
#define _ETH_IOCTL_H_

/* Commands explanation.                                                     */

/* ETH_HWADDR : Will write in priv the Physical MAC address of the           */
/*              current Ethernet card. (the size of MAC addr is 48 bits.)    */

/* ETH_BLOCKING_READ : Will turn the read operation blocking. read will not  */
/*                     return til any data is received.                      */

/* ETH_NON_BLOCKIN_READ : Will turn the read operation as non blocking.      */
/*                        The read call will return with or without (in      */
/*                        case not any) data */

/* SET_PROTOCOL_FILTER : Will set the receiving protocol filter. By default  */
/*                       the driver only receives RT_EP packets. You can     */
/*                       configure to receive only packets defined in priv   */
/*                       (unsigned short *) (IP, NETBIOS, etc..              */
/*                       <see include/drivers/if_ether.h> for protocol       */
/*                       numbers). If set to 0, the driver will receive all  */
/*                       protocol packets on the net.                        */

/* GET_PROTOCOL_FILTER : Will write in priv (unsigned short) the current     */
/*                       protocol filter.                                    */
/*                       If protocol 0, the protocol filter is disabled      */


#define ETH_HWADDR             0x500  
#define ETH_BLOCKING_READ      0x501
#define ETH_NON_BLOCKING_READ  0x502
#define SET_PROTOCOL_FILTER    0x503
#define GET_PROTOCOL_FILTER    0x504

#endif
