/*----------------------------------------------------------------------------
 *-------------------------         R T - E P         ------------------------
 *----------------------------------------------------------------------------
 *                                                             {MARTE_VERSION}
 *
 *                          'p r i o _ q u e u e . h'
 *
 *                                     C
 *
 *                                               
 * File 'prio_queue.h'                                                By Chema.
 *                                                          Jose Maria Martinez
 *                                                         <martinjm@unican.es>
 *
 * Priority queues (heaps) module.
 *
 *
 *---------------------------------------------------------------------------*/
 /*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.
 */

#ifndef FILE_PRIO_QUEUE_H
#define FILE_PRIO_QUEUE_H

#include <stdio.h>
#include "prot_types.h"
#include "prio_element.h"
#include "prio_priority.h"


#define QUEUE_EMPTY -1


typedef struct {
  priority_t Pri;
  element_t *E;
} cell_t;

typedef struct{
  positive_t Length;
  positive_t queue_size;
  cell_t *Q;
} queue_t;


extern void init_queue(queue_t *Q); 

extern boolean empty(queue_t *Q);
/* empty returns 0 if the queue Q is empty. */ 

extern positive_t length_queue(queue_t *Q);

extern int enqueue(element_t *E, priority_t P, queue_t *Q);

extern int dequeue(element_t **E, priority_t *P, queue_t *Q);

// Return TRUE if we find the element

//extern boolean dequeue_middle(element_t *E, priority_t *P, queue_t *Q);  
/* dequeue_middle returns FALSE if not found. */

extern int read_first(element_t **E, priority_t *P, queue_t *Q);

//extern boolean set_prio(element_t E, priority_t P,queue_t *Q);
/* set_prio returns FALSE if not found */


/* Only for testing.*/
extern cell_t *dynamic_array(cell_t *p, positive_t pos );

#endif /*FILE_PRIO_QUEUE_H*/
