/*-------------------------         R T - E P         ------------------------
 *----------------------------------------------------------------------------
 *                                                             {LINUX_VERSION}
 *
 *                  't e s t _ p r o t o c o l . c'
 *
 *                                     C
 *
 *                                               
 * File 'test_protocol.c'                                             By Chema.
 *                                                          Jose Maria Martinez
 *                                                         <martinjm@unican.es>
 *
 * Basic RT-EP testing. 
 *
 *
 *---------------------------------------------------------------------------*/
 /*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.
 */

#include <stdio.h>
#include <pthread.h>
//#include "rt_comm.h"
//#include "prot_types.h"


 // Linux includes.
#include <sys/types.h>
#include <sys/stat.h>

#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/utsname.h>
#include <net/if.h>
#include <fcntl.h>
#include <linux/if_packet.h>
#include <time.h>
#include "/home/chema/marte/include/net/if_ether.h"
//#include <asm/msr.h>
//#include <errno.h>
//#include "/home/chema/marte/misc.h"

#define STATION_MASTER
/* #define STATION_SLAVE */

#ifdef STATION_MASTER

#define ADDR_DEST0 0x00
#define ADDR_DEST1 0x08
#define ADDR_DEST2 0x9B
#define ADDR_DEST3 0x80
#define ADDR_DEST4 0x05
#define ADDR_DEST5 0xB2
#endif


#define RT_EP_PROTOCOL 0x1000


#define PROCESS_ID 1

char *elements[10]={"Me llamo andresito",
		    "Me llamo Juan",
		    "Me llamo Luis",
		    "Me llamo Andres",
		    "Me llamo Jaime",
		    "Me llamo Raul",
		    "Me llamo Jose",
		    "Me llamo Martin",
		    "Me llamo Pedro",
		    "Me llamo Fede" };


typedef struct {
  struct ethhdr eth_header;
  char data[1500];
} token_packet_t;


main(){
  int i,j;

  char c;
struct sockaddr_ll current_sta_addr;
int socket_srv;
  struct ifreq ifr;
  //   unsigned char Buffer[1536];    
   typedef struct ethhdr
     {
       unsigned char   h_dest[ETH_ALEN];       /* destination eth addr */
       unsigned char   h_source[ETH_ALEN];     /* source ether addr    */
       unsigned short  h_proto;                /* packet type ID field */
      
   } eth_header_t;
   
   struct {
     eth_header_t eth_header;
     char data[1500];
   } Buffer;

  char *device="eth0";
  token_packet_t token_UDP;
  struct packet_mreq opcion;
  int status;
  int Fd;
  
      if((socket_srv=socket(PF_PACKET,SOCK_RAW,htons(RT_EP_PROTOCOL))) < 0 ){
	perror("Creation of socket_srv");
	return -1;
      }
      /*  we attempt to achieve the MAC address of the current station. */
      memset(&ifr,0,sizeof(struct ifreq));

      strcpy(ifr.ifr_name, device );
      if(ioctl(socket_srv, SIOCGIFHWADDR, &ifr) < 0 ){
	perror("ioctl:SIOCGIFHADDR");
	exit(-1);
      }
      memcpy(current_sta_addr.sll_addr,ifr.ifr_addr.sa_data,ETH_ALEN);
      memcpy(token_UDP.eth_header.h_source, current_sta_addr.sll_addr, ETH_ALEN);

      eth_printf("Current MAC: %!\n",current_sta_addr.sll_addr);
      /*  we now try to fetch the interface index. */
      if(ioctl(socket_srv, SIOGIFINDEX, &ifr) < 0 ){
	perror("ioctl:SIOGIFINDEX");
	exit(-1);
      }
      current_sta_addr.sll_ifindex=ifr.ifr_ifindex;
      current_sta_addr.sll_ifindex=2;
      /*we also have to inicialize the other fields of current_sta_addr*/
      current_sta_addr.sll_family=AF_PACKET;
      current_sta_addr.sll_protocol=htons(RT_EP_PROTOCOL);
      current_sta_addr.sll_halen=ETH_ALEN;

      //     bind( socket_srv, (struct sockaddr*)&current_sta_addr,
      //    sizeof(current_sta_addr));
      /*Now we set promiscuous mode.*/
       memset(&opcion,0,sizeof(opcion));
       opcion.mr_ifindex=ifr.ifr_ifindex;
       opcion.mr_type=PACKET_MR_PROMISC;
       status=setsockopt(socket_srv, SOL_PACKET, PACKET_ADD_MEMBERSHIP,
			 (void *)&opcion,(socklen_t)sizeof(opcion));
      
  token_UDP.eth_header.h_dest[0]=0x00;
  token_UDP.eth_header.h_dest[1]=0xE0;
  token_UDP.eth_header.h_dest[2]=0x4B;
  token_UDP.eth_header.h_dest[3]=0x02;
  token_UDP.eth_header.h_dest[4]=0x8D;
  token_UDP.eth_header.h_dest[5]=0x02;
  token_UDP.eth_header.h_proto=htons(RT_EP_PROTOCOL);
  printf("Protocolo: %d",RT_EP_PROTOCOL);

  memcpy( token_UDP.data, elements[2],13 );
  //  Fd = open("output.txt", O_RDWR | O_CREAT, S_IRWXU);
  // for(i=0;i<2;i++){
  i=0;
  do {
    status=recvfrom(socket_srv, &Buffer, sizeof(Buffer), 0, NULL, 0);
    printf("Packet %d - Frame Length: %d, Protocol: %x \n",i,
	   status, ntohs(Buffer.eth_header.h_proto));
    eth_printf("Source Address: %! : ",Buffer.eth_header.h_source);
    eth_printf("Destination Address: %! : \n",Buffer.eth_header.h_dest);

    //    status=sendto(socket_srv,&token_UDP,sizeof(token_UDP),0,NULL,0);
/*        length_msg=recvfrom(socket_srv,buffer,BUFFER,0,NULL,0); */
     
    //   status=sendto(socket_srv,&token_UDP,sizeof(token_UDP),0,NULL,0);
 //   write(Fd, Buffer.data, strlen(Buffer.data));
    i++;
  } while(1);//strncmp(Buffer.data,"END",strlen("END")) !=0);
  close(socket_srv);

}//end main.
