/*----------------------------------------------------------------------------
 *-------------------------         R T - E P         ------------------------
 *----------------------------------------------------------------------------
 *                                                             {MARTE_VERSION}
 *
 *                        'r t _ e p _ e r r o r n . h'
 *
 *                                     C
 *
 *                                               
 * File 'rt_ep_errorn.h'                                               By Chema.
 *                                                          Jose Maria Martinez
 *                                                         <martinjm@unican.es>
 *
 * Error codes of RT-EP Protocol. 
 *
 *
 *---------------------------------------------------------------------------*/
 /*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.
 */


#ifndef FILE_RT_EP_ERRORN_H
#define FILE_RT_EP_ERRORN_H


/*************************************************************/
/* We define some common error defines                       */
/*                                                           */
/* CREATION_ERROR : When threre is an error in creating a    */
/*                  mutex or a conditional variable          */
/* SYNCH_ERROR : Synch error when attempting to lock/unlock  */
/*               a mutex or raising/waiting for conditional  */
/*               variable signal.                            */
#define CREATION_ERROR -30
#define SYNCH_ERROR    -20

#define UNEXPECTED_ERROR  -55

// lnk_config.h 
#define STA_NOT_VALID     -10
#define STA_NOT_FOUND     -9
#define STATIONS_OVERFLOW -31
#define FILE_ERROR        -21


// rt_comm.h defines.
#define INFO_LENGTH_OVERFLOW -2
#define INVALID_PRIORITY     -3
#define INVALID_CHANNEL      -4
#define NO_ELEMENTS          -5


#endif /*FILE_RT_EP_ERRORN_H*/

