/*-------------------------         R T - E P         ------------------------
 *----------------------------------------------------------------------------
 *                                                             {LINUX_VERSION}
 *
 *                  't e s t _ p r o t o c o l . c'
 *
 *                                     C
 *
 *                                               
 * File 'test_protocol.c'                                             By Chema.
 *                                                          Jose Maria Martinez
 *                                                         <martinjm@unican.es>
 *
 * Basic RT-EP testing. 
 *
 *
 *---------------------------------------------------------------------------*/
 /*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.
 */

#include <stdio.h>
#include <pthread.h>
#include <unistd.h>
#include "rt_comm.h"
#include "prot_types.h"
#include <debug_marte.h> // For Debugging

// #define STATION_MASTER
/* #define STATION_SLAVE */

#ifdef STATION_MASTER
/* BTMMMI -> Mandos. */
//# Target Mandos
// hardware ethernet 00:08:9B:80:05:B2;
// dest:  hardware ethernet 00:08:9B:80:09:60;

char addr_dest[6]={0x00,0x02,0xB3,0xD1,0x34,0xBF};
#endif

#ifdef STATION_SLAVE

/* BTMCONT -> Controlador. */
// # Target controlador del robot
// hardware ethernet 00:08:9B:80:09:60;
// dest:   hardware ethernet 00:08:9B:80:05:B2;

char addr_dest[6]= {0x00,0x02,0xB3,0xD1,0x30,0xEC};

#endif


#define PROCESS_ID 1

char *elements[10]={"Me llamo andresito.",
		    "Me llamo Juan.",
		    "Me llamo Luis.",
		    "Me llamo Andres.",
		    "Me llamo Jaime.",
		    "Me llamo Raul.",
		    "Me llamo Jose.",
		    "Me llamo Martin.",
		    "Me llamo Pedro.",
		    "Me llamo Fede." };

int len[10] = {19,14,14,16,15,14,14,16,15,14 };

unsigned int prioridad[10]={100,90,80,70,60,50,40,30,20,10};

void send_to_sta(){
  int i;

  printf("test_protocol:send_to_sta()>Starting...\n");

/*   for(i=0;i<10;i++){ */
  for(;;){
   i = i % 10;
   send_info(addr_dest, PROCESS_ID, elements[i], len[i], prioridad[i]);
   printf("sender:> E: %s ; P: %u\n",elements[i],prioridad[i]);
   sleep(5);
   i++;
  }//end for.
  printf("test_protocol:send_to_sta()>Finishing...\n");
}//end function send_info.

void recv_from_sta(){

  //  int i;
  char addr_source[6];
  char buffer[1000];
  unsigned char prioridad;
  int len;
  printf("test_protocol:recv_from_sta()>Starting...\n");

/*   for(i=0;i<10;i++){ */
  memset(buffer,0,1000);
  for(;;){
   len = recv_info(addr_source, PROCESS_ID, buffer, &prioridad);
   printf("receiver:> E: %s ; P: %u\n", buffer ,prioridad);
  }//end for.
  printf("test_protocol:recv_from_sta()>Finishing...\n");
}//end recv_from_sta.

int main(void){

  pthread_t sender,receiver;

#ifdef STATION_MASTER
  // For Debugging
  //init_serial_communication_with_gdb (SERIAL_PORT_1);
  //set_break_point_here;
#endif

  printf("test_protocol:main()> We TRY to inicialize the link\n");
  init_comm(22);
  printf("test_protocol:main()> We HAVE inicialized the link. And wait\n");

  printf("test_protocol:main()> We launch the threads.\n"); 
   if( pthread_create(&sender,NULL,(void *)send_to_sta,(void *)NULL) != 0){ 
    printf("test_protocol:main()> Test_Sender thread creation error.\n");
    exit(UNEXPECTED_ERROR);
  }

 printf("test_protocol:main() The Sender thread is launched.\n");

 if( pthread_create(&receiver,NULL,(void *)recv_from_sta,(void *)NULL) != 0){
    printf("test_protocol:main()> Test_Received thread creation error.\n");
    exit(UNEXPECTED_ERROR);
  }

 printf("test_protocol:main() The Received thread is launched.\n");

  while(1){
    if(getchar()=='x')
      exit(0);
  }

  return 0;
}//end main.
